// Copyright (C) 2007-2008  Gelenberg Andrej
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

#ifndef DED_H
#define DED_H

extern const char * const prog_name;
extern char verbose;

enum error {
	NO_ERROR = 0,

	// Fehlernummern bei ausgang
	ERR_EXIT_ARGS,
	ERR_EXIT_NO_MRTREE_FOUND,
	ERR_EXIT_FORK, // Fehler beim Forking
	ERR_EXIT_SID,
	ERR_EXIT_CHDIR,

	ERR_EXIT_NO_MEM,

	// Fehlernummern bei Laden von Match-Regeln
	ERR_LR_STAT,
	ERR_LR_OPEN,
	ERR_LR_READ,
	ERR_LR_PARSE,

	// Fehlernummern in bus-modul
	ERR_BUS_CONNECTION,
	ERR_BUS_ADD_RULES
};

struct err_s {
	char to_free;
	char *msg;
};

#define err_free(err) if(err.to_free)free(err.msg);

#endif // DED_H
