#!/bin/bash

# Copyright (C) 2007-2008  Gelenberg Andrej
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

if [ ! -x "$1" ]
then
	echo "ERROR: \"$1\" is not executable!" >&2
	exit 1
fi

max_arg=$(( `$1` - 1 ))
i=0
args=$( while [ $i -le $max_arg ]
do
	echo "	arg$i CDATA #IMPLIED"
	i=$(echo $i + 1|bc)
done )

cat << EOD
<!ELEMENT dbused (match+)>
<!ELEMENT match (match|exec|fork|send)+>
<!ELEMENT exec (#PCDATA)>
<!ELEMENT fork (#PCDATA)>
<!ELEMENT send EMPTY>

<!ATTLIST dbused
	bus (system|session) #REQUIRED
>

<!ATTLIST send
	type CDATA #REQUIRED
	path CDATA #IMPLIED
	interface CDATA #IMPLIED
	destination CDATA #IMPLIED
	member CDATA #IMPLIED
	bus CDATA #IMPLIED
$args
>


<!ATTLIST match
	type CDATA #IMPLIED
	sender CDATA #IMPLIED
	interface CDATA #IMPLIED
	member NMTOKEN #IMPLIED
	path CDATA #IMPLIED
	destination CDATA #IMPLIED
$args
>
EOD
